-- Generated by Lava 2000

entity
  vdd
is
port
  ( clk   : in bit
  ; outp  : out bit
  );
end entity vdd;

entity
  gnd
is
port
  ( clk   : in bit
  ; outp  : out bit
  );
end entity gnd;

entity
  id
is
port
  ( clk   : in bit
  ; inp   : in bit
  ; outp  : out bit
  );
end entity id;

entity
  inv
is
port
  ( clk   : in bit
  ; inp   : in bit
  ; outp  : out bit
  );
end entity inv;

entity
  and2
is
port
  ( clk   : in bit
  ; inp_1 : in bit
  ; inp_2 : in bit
  ; outp  : out bit
  );
end entity and2;

entity
  or2
is
port
  ( clk   : in bit
  ; inp_1 : in bit
  ; inp_2 : in bit
  ; outp  : out bit
  );
end entity or2;

entity
  xor2
is
port
  ( clk   : in bit
  ; inp_1 : in bit
  ; inp_2 : in bit
  ; outp  : out bit
  );
end entity xor2;

entity
  delay
is
port
  ( clk   : in bit
  ; init  : in bit
  ; inp   : in bit
  ; outp  : out bit
  );
end entity delay;

---------------------------------------------------------------------
-- behavioral descriptions

architecture
  behavioral
of
  vdd
is
begin
  outp <= '1';
end;

architecture
  behavioral
of
  gnd
is
begin
  outp <= '0';
end;

architecture
  behavioral
of
  id
is
begin
  outp <= inp;
end;

architecture
  behavioral
of
  inv
is
begin
  outp <= not inp;
end;

architecture
  behavioral
of
  and2
is
begin
  outp <= inp_1 and inp_2;
end;

architecture
  behavioral
of
  or2
is
begin
  outp <= inp_1 or inp_2;
end;

architecture
  behavioral
of
  xor2
is
begin
  outp <= inp_1 xor inp_2;
end;

architecture
  behavioral
of
  delay
is
begin
  latch : process is
    variable state : bit;
  begin
    state := init;
    loop
      wait until clk = '1';
      outp <= state;
      state := inp;
    end loop;
  end process latch;
end;

---------------------------------------------------------------------
-- the end.

use work.all;

entity
  fullAdder
is
port
  -- clock
  ( clk : in bit

  -- inputs
  ; inp_1 : in bit
  ; inp_2_1 : in bit
  ; inp_2_2 : in bit

  -- outputs
  ; outp_0 : out bit
  ; outp_1 : out bit
  );
end entity fullAdder;

architecture
  structural
of
  fullAdder
is
  signal w1 : bit;
  signal w2 : bit;
  signal w3 : bit;
  signal w4 : bit;
  signal w5 : bit;
  signal w6 : bit;
  signal w7 : bit;
  signal w8 : bit;
begin
  c_w2      : entity id    port map (clk, inp_1, w2);
  c_w4      : entity id    port map (clk, inp_2_1, w4);
  c_w5      : entity id    port map (clk, inp_2_2, w5);
  c_w3      : entity xor2  port map (clk, w4, w5, w3);
  c_w1      : entity xor2  port map (clk, w2, w3, w1);
  c_w7      : entity and2  port map (clk, w2, w3, w7);
  c_w8      : entity and2  port map (clk, w4, w5, w8);
  c_w6      : entity xor2  port map (clk, w7, w8, w6);

  -- naming outputs
  c_outp_0  : entity id    port map (clk, w1, outp_0);
  c_outp_1  : entity id    port map (clk, w6, outp_1);
end structural;
